Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../ModelProcessorx.h"
@@ -87,5 +87,5 @@
 
 	/*figure out times: */
-	timesx=(double*)xmalloc(Nx*sizeof(double));
+	timesx=xNew<double>(Nx);
 	for(j=0;j<Nx;j++){
 		timesx[j]=spcvx[(Mx-1)*Nx+j];
@@ -94,5 +94,5 @@
 	UnitConversion(timesx,Nx,ExtToIuEnum,TimeEnum);
 	/*figure out times: */
-	timesy=(double*)xmalloc(Ny*sizeof(double));
+	timesy=xNew<double>(Ny);
 	for(j=0;j<Ny;j++){
 		timesy[j]=spcvy[(My-1)*Ny+j];
@@ -101,5 +101,5 @@
 	UnitConversion(timesy,Ny,ExtToIuEnum,TimeEnum);
 	/*figure out times: */
-	timesz=(double*)xmalloc(Nz*sizeof(double));
+	timesz=xNew<double>(Nz);
 	for(j=0;j<Nz;j++){
 		timesz[j]=spcvz[(Mz-1)*Nz+j];
@@ -107,5 +107,4 @@
 	/*unit conversion: */
 	UnitConversion(timesz,Nz,ExtToIuEnum,TimeEnum);
-
 
 	/*Create spcs from x,y,z, as well as the spc values on those spcs: */
@@ -121,9 +120,9 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
@@ -136,9 +135,9 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
@@ -146,5 +145,5 @@
 
 					}
-					else _error_("if vertices_type is MacAyealPattyn, you shoud have nodeonpattyn or nodeonmacayeal");
+					else _error2_("if vertices_type is MacAyealPattyn, you shoud have nodeonpattyn or nodeonmacayeal");
 			}
 			/*Also add spcs of coupling: zero at the border pattyn/stokes for the appropriate dofs*/
@@ -158,9 +157,9 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
@@ -173,18 +172,18 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvz[i])){
+						if (!xIsNan<IssmDouble>(spcvz[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,spcvz[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
 					}
-					else _error_("if vertices_type is PattynStokes, you shoud have nodeonpattyn or nodeonstokes");
+					else _error2_("if vertices_type is PattynStokes, you shoud have nodeonpattyn or nodeonstokes");
 			}
 			/*Also add spcs of coupling: zero at the border pattyn/stokes for the appropriate dofs*/
@@ -198,9 +197,9 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
@@ -213,22 +212,22 @@
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
-						if (!isnan(spcvx[i])){
+						if (!xIsNan<IssmDouble>(spcvx[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvy[i])){
+						if (!xIsNan<IssmDouble>(spcvy[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
-						if (!isnan(spcvz[i])){
+						if (!xIsNan<IssmDouble>(spcvz[i])){
 							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,spcvz[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 							count++;
 						}
 					}
-					else _error_("if vertices_type is MacAyealStokes, you shoud have nodeonmacayeal or nodeonstokes");
+					else _error2_("if vertices_type is MacAyealStokes, you shoud have nodeonmacayeal or nodeonstokes");
 			}
 			/*Now add the regular spcs*/
 			else{
-				if (Mx==numberofvertices && !isnan(spcvx[i])){
+				if (Mx==numberofvertices && !xIsNan<IssmDouble>(spcvx[i])){
 					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,spcvx[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 					count++;
@@ -236,9 +235,9 @@
 				else if (Mx==numberofvertices+1) {
 					/*figure out times and values: */
-					values=(double*)xmalloc(Nx*sizeof(double));
+					values=xNew<double>(Nx);
 					spcpresent=false;
 					for(j=0;j<Nx;j++){
 						values[j]=spcvx[i*Nx+j]/yts;
-						if(!isnan(values[j]))spcpresent=true; //NaN means no spc by default
+						if(!xIsNan<IssmDouble>(values[j]))spcpresent=true; //NaN means no spc by default
 					}
 
@@ -247,5 +246,5 @@
 						count++;
 					}
-					xfree((void**)&values);
+					xDelete<double>(values);
 				}
 				else if (vertices_type[i]==HutterApproximationEnum){
@@ -254,5 +253,5 @@
 				}
 
-				if (My==numberofvertices && !isnan(spcvy[i])){
+				if (My==numberofvertices && !xIsNan<IssmDouble>(spcvy[i])){
 					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,spcvy[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vy.
 					count++;
@@ -260,9 +259,9 @@
 				else if (My==numberofvertices+1){
 					/*figure out times and values: */
-					values=(double*)xmalloc(Ny*sizeof(double));
+					values=xNew<double>(Ny);
 					spcpresent=false;
 					for(j=0;j<Ny;j++){
 						values[j]=spcvy[i*Ny+j]/yts;
-						if(!isnan(values[j]))spcpresent=true; //NaN means no spc by default
+						if(!xIsNan<IssmDouble>(values[j]))spcpresent=true; //NaN means no spc by default
 					}
 					if(spcpresent){
@@ -270,5 +269,5 @@
 						count++;
 					}
-					xfree((void**)&values);
+					xDelete<double>(values);
 				}
 				else if (vertices_type[i]==HutterApproximationEnum){
@@ -278,5 +277,5 @@
 
 				if ((int)vertices_type[i]==StokesApproximationEnum ||  ((int)vertices_type[i]==NoneApproximationEnum)){
-					if (Mz==numberofvertices && !isnan(spcvz[i])){
+					if (Mz==numberofvertices && !xIsNan<IssmDouble>(spcvz[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,spcvz[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
 						count++;
@@ -284,9 +283,9 @@
 					else if (Mz==numberofvertices+1){
 						/*figure out times and values: */
-						values=(double*)xmalloc(Nz*sizeof(double));
+						values=xNew<double>(Nz);
 						spcpresent=false;
 						for(j=0;j<Nz;j++){
 							values[j]=spcvz[i*Nz+j]/yts;
-							if(!isnan(values[j]))spcpresent=true; //NaN means no spc by default
+							if(!xIsNan<IssmDouble>(values[j]))spcpresent=true; //NaN means no spc by default
 						}
 						if(spcpresent){
@@ -294,5 +293,5 @@
 							count++;
 						}
-						xfree((void**)&values);
+						xDelete<double>(values);
 					}
 
@@ -319,5 +318,5 @@
 						count++;
 						break;
-					default: _error_("Vertex approximation %s not supported",EnumToStringx((int)vertices_type[i]));
+					default: _error2_("Vertex approximation " << EnumToStringx((int)vertices_type[i]) << " not supported");
 				}
 			}
@@ -326,21 +325,21 @@
 	  
 	/*Free data: */
-	xfree((void**)&spcvx);
-	xfree((void**)&spcvy);
-	xfree((void**)&spcvz);
-	xfree((void**)&nodeonmacayeal);
-	xfree((void**)&nodeonpattyn);
-	xfree((void**)&nodeonstokes);
-	xfree((void**)&nodeonicesheet);
-	xfree((void**)&nodeonbed);
-	xfree((void**)&vertices_type);
-	xfree((void**)&surface);
-	xfree((void**)&z);
+	xDelete<double>(spcvx);
+	xDelete<double>(spcvy);
+	xDelete<double>(spcvz);
+	xDelete<double>(nodeonmacayeal);
+	xDelete<double>(nodeonpattyn);
+	xDelete<double>(nodeonstokes);
+	xDelete<double>(nodeonicesheet);
+	xDelete<double>(nodeonbed);
+	xDelete<double>(vertices_type);
+	xDelete<double>(surface);
+	xDelete<double>(z);
 
 	/*Free resources:*/
-	xfree((void**)&timesx);
-	xfree((void**)&timesy);
-	xfree((void**)&timesz);
-	xfree((void**)&values);
+	xDelete<double>(timesx);
+	xDelete<double>(timesy);
+	xDelete<double>(timesz);
+	xDelete<double>(values);
 
 	/*Assign output pointer: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
@@ -120,6 +120,6 @@
 	/*Free data: */
 	iomodel->DeleteData(3,DiagnosticIcefrontEnum,ThicknessEnum,BedEnum);
-	xfree((void**)&elements_type);
-	xfree((void**)&pressureload);
+	xDelete<double>(elements_type);
+	xDelete<double>(pressureload);
 
 	/*Create Penpair for penalties: */
@@ -144,5 +144,5 @@
 
 	/*free ressources: */
-	xfree((void**)&penalties);
+	xDelete<double>(penalties);
 
 	/*Create Riffront loads for rifts: */
@@ -157,5 +157,5 @@
 		}
 		iomodel->DeleteData(5,RiftsRiftstructEnum,ThicknessEnum,BedEnum,SurfaceEnum,MaskVertexonfloatingiceEnum);
-		xfree((void**)&riftfront);
+		xDelete<Riftfront>(riftfront);
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../ModelProcessorx.h"
@@ -60,10 +60,10 @@
 			}
 			else{
-				if (!isnan(iomodel->Data(DiagnosticSpcvxEnum)[i])){
+				if (!xIsNan<IssmDouble>(iomodel->Data(DiagnosticSpcvxEnum)[i])){
 					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,iomodel->Data(DiagnosticSpcvxEnum)[i]/yts,DiagnosticHutterAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 					count++;
 				}
 
-				if (!isnan(iomodel->Data(DiagnosticSpcvyEnum)[i])){
+				if (!xIsNan<IssmDouble>(iomodel->Data(DiagnosticSpcvyEnum)[i])){
 					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,iomodel->Data(DiagnosticSpcvyEnum)[i]/yts,DiagnosticHutterAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
 					count++;
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../modules/modules.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../ModelProcessorx.h"
@@ -56,5 +56,5 @@
 				count++;
 			}
-			else if (!isnan(iomodel->Data(DiagnosticSpcvzEnum)[i])){
+			else if (!xIsNan<IssmDouble>(iomodel->Data(DiagnosticSpcvzEnum)[i])){
 				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,
 								iomodel->Data(DiagnosticSpcvzEnum)[i]/yts,DiagnosticVertAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/UpdateElementsDiagnosticVert.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/UpdateElementsDiagnosticVert.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DiagnosticVert/UpdateElementsDiagnosticVert.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../modules/modules.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 	
-void DistributeNumDofs(DofIndexing* index,int analysis_type,double* vertices_type){
+void DistributeNumDofs(DofIndexing* index,int analysis_type,IssmDouble* vertices_type){
 
 	/*For now, we distribute by analysis_type, later, we will distribute using the analysis_type,
@@ -35,5 +35,5 @@
 		else if (vertices_type[0]==MacAyealPattynApproximationEnum){
 			numdofs=4;
-			doftype=(int*)xmalloc(numdofs*sizeof(int));
+			doftype=xNew<int>(numdofs);
 			doftype[0]=MacAyealApproximationEnum;
 			doftype[1]=MacAyealApproximationEnum;
@@ -43,5 +43,5 @@
 		else if (vertices_type[0]==PattynStokesApproximationEnum){
 			numdofs=6;
-			doftype=(int*)xmalloc(numdofs*sizeof(int));
+			doftype=xNew<int>(numdofs);
 			doftype[0]=PattynApproximationEnum;
 			doftype[1]=PattynApproximationEnum;
@@ -53,5 +53,5 @@
 		else if (vertices_type[0]==MacAyealStokesApproximationEnum){
 			numdofs=6;
-			doftype=(int*)xmalloc(numdofs*sizeof(int));
+			doftype=xNew<int>(numdofs);
 			doftype[0]=MacAyealApproximationEnum;
 			doftype[1]=MacAyealApproximationEnum;
@@ -61,5 +61,5 @@
 			doftype[5]=StokesApproximationEnum;
 		}
-		else _error_("Approximationtype %i (%s) not implemented yet for DiagnosticHoriz",(int)*vertices_type,EnumToStringx((int)*vertices_type));
+		else _error2_("Approximationtype " << reCast<int>(*vertices_type) << " (" << EnumToStringx(reCast<int>(*vertices_type)) << ") not implemented yet for DiagnosticHoriz");
 	}
 	else if (analysis_type==DiagnosticVertAnalysisEnum){
@@ -90,5 +90,5 @@
 		numdofs=1;
 	}
-	else _error_("analysis type: %i (%s) not implemented yet",analysis_type,EnumToStringx(analysis_type));
+	else _error2_("analysis type: " << analysis_type << " (" << EnumToStringx(analysis_type) << ") not implemented yet");
 
 	/*Now initialize the index*/
@@ -96,4 +96,4 @@
 
 	/*Clean up*/
-	 xfree((void**)&doftype);
+	 xDelete<int>(doftype);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include <string.h>
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
@@ -42,8 +42,8 @@
 	int  el1,el2;
 	int    dim;
-	double* elements=NULL;
-	double* elements2d=NULL;
-	double* riftinfo=NULL;
-	double* vertex_pairing=NULL;
+	IssmDouble* elements=NULL;
+	IssmDouble* elements2d=NULL;
+	IssmDouble* riftinfo=NULL;
+	IssmDouble* vertex_pairing=NULL;
 
 	/*Fetch parameters: */
@@ -76,6 +76,6 @@
 
 	/*Free elements and elements2d: */
-	xfree((void**)&elements);
-	xfree((void**)&elements2d);
+	xDelete<IssmDouble>(elements);
+	xDelete<IssmDouble>(elements2d);
 
 	/*Deal with rifts, they have to be included into one partition only, not several: */
@@ -83,14 +83,14 @@
 		iomodel->FetchData(&riftinfo,&numrifts,NULL,RiftsRiftstructEnum);
 		for(i=0;i<numrifts;i++){
-			el1=(int)*(riftinfo+RIFTINFOSIZE*i+2)-1; //matlab indexing to c indexing
-			el2=(int)*(riftinfo+RIFTINFOSIZE*i+3)-1; //matlab indexing to c indexing
+			el1=reCast<int>(*(riftinfo+RIFTINFOSIZE*i+2))-1; //matlab indexing to c indexing
+			el2=reCast<int>(*(riftinfo+RIFTINFOSIZE*i+3))-1; //matlab indexing to c indexing
 			epart[el2]=epart[el1]; //ensures that this pair of elements will be in the same partition, as well as the corresponding vertices;
 		}
-		xfree((void**)&riftinfo); 
+		xDelete<IssmDouble>(riftinfo); 
 	}
 
 	/*Used later on: */
-	my_vertices=(int*)xcalloc(numberofvertices,sizeof(int));
-	my_elements=(bool*)xcalloc(numberofelements,sizeof(bool));
+	my_vertices=xNewZeroInit<int>(numberofvertices);
+	my_elements=xNewZeroInit<bool>(numberofelements);
 
 	/*Start figuring out, out of the partition, which elements belong to this cpu: */
@@ -107,17 +107,17 @@
 			 into the vertices coordinates. If we start plugging 1 into my_vertices for each index[n][i] (i=0:2), then my_vertices 
 			 will hold which vertices belong to this partition*/
-			my_vertices[(int)*(elements+elements_width*i+0)-1]=1;
-			my_vertices[(int)*(elements+elements_width*i+1)-1]=1;
-			my_vertices[(int)*(elements+elements_width*i+2)-1]=1;
+			my_vertices[reCast<int>(*(elements+elements_width*i+0))-1]=1;
+			my_vertices[reCast<int>(*(elements+elements_width*i+1))-1]=1;
+			my_vertices[reCast<int>(*(elements+elements_width*i+2))-1]=1;
 			
 			if(elements_width==6){
-				my_vertices[(int)*(elements+elements_width*i+3)-1]=1;
-				my_vertices[(int)*(elements+elements_width*i+4)-1]=1;
-				my_vertices[(int)*(elements+elements_width*i+5)-1]=1;
+				my_vertices[reCast<int>(*(elements+elements_width*i+3))-1]=1;
+				my_vertices[reCast<int>(*(elements+elements_width*i+4))-1]=1;
+				my_vertices[reCast<int>(*(elements+elements_width*i+5))-1]=1;
 			}
 		}
 	}//for (i=0;i<numberofelements;i++)
 	/*Free data : */
-	xfree((void**)&elements);
+	xDelete<IssmDouble>(elements);
 
 	/*We might have vertex_pairing in which case, some vertices have to be cloned:
@@ -126,20 +126,20 @@
 	iomodel->FetchData(&vertex_pairing,&numvertex_pairing,NULL,DiagnosticVertexPairingEnum);
 	for(i=0;i<numvertex_pairing;i++){
-		if(my_vertices[(int)vertex_pairing[2*i+0]-1] && !my_vertices[(int)vertex_pairing[2*i+1]-1]){
-			my_vertices[(int)vertex_pairing[2*i+1]-1]=2; //to know that these elements are not on the partition
+		if(my_vertices[reCast<int>(vertex_pairing[2*i+0])-1] && !my_vertices[reCast<int>(vertex_pairing[2*i+1])-1]){
+			my_vertices[reCast<int>(vertex_pairing[2*i+1])-1]=2; //to know that these elements are not on the partition
 		}
 	}
-	xfree((void**)&vertex_pairing);
+	xDelete<IssmDouble>(vertex_pairing);
 	iomodel->FetchData(&vertex_pairing,&numvertex_pairing,NULL,PrognosticVertexPairingEnum);
 	for(i=0;i<numvertex_pairing;i++){
-		if(my_vertices[(int)vertex_pairing[2*i+0]-1] && !my_vertices[(int)vertex_pairing[2*i+1]-1]){
-			my_vertices[(int)vertex_pairing[2*i+1]-1]=2; //to know that these elements are not on the partition
+		if(my_vertices[reCast<int>(vertex_pairing[2*i+0])-1] && !my_vertices[reCast<int>(vertex_pairing[2*i+1])-1]){
+			my_vertices[reCast<int>(vertex_pairing[2*i+1])-1]=2; //to know that these elements are not on the partition
 		}
 	}
-	xfree((void**)&vertex_pairing);
+	xDelete<IssmDouble>(vertex_pairing);
 
 	/*Free ressources:*/
-	xfree((void**)&npart);
-	xfree((void**)&epart);
+	xDelete<int>(npart);
+	xDelete<int>(epart);
 
 	/*Assign output pointers:*/
